Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
PGScrollFrame Class Reference

This is a special kind of frame that pretends to be much larger than it actually is. More...

`#include "pgScrollFrame.h"`

Inheritance diagram for PGScrollFrame:

## Public Member Functions
| PGScrollFrame (const std::string &name="")
void | clear_horizontal_slider ()
| Removes the horizontal scroll bar from control of the frame.
void | clear_vertical_slider ()
| Removes the vertical scroll bar from control of the frame.
void | clear_virtual_frame ()
| Removes the virtual frame from the item.
virtual bool | cull_callback (CullTraverser *trav, CullTraverserData &data)
| This function will be called during the cull traversal to perform any additional operations that should be performed at cull time.
virtual TypeHandle | force_init_type ()
bool | get_auto_hide () const
| Returns the auto_hide flag.
PGSliderBar * | get_horizontal_slider () const
| Returns the PGSliderBar that serves as the horizontal scroll bar for this frame, if any, or NULL if it is not set.
bool | get_manage_pieces () const
| Returns the manage_pieces flag.
virtual TypeHandle | get_type () const
PGSliderBar * | get_vertical_slider () const
| Returns the PGSliderBar that serves as the vertical scroll bar for this frame, if any, or NULL if it is not set.
const LVecBase4 & | get_virtual_frame () const
| Returns the bounding rectangle of the virtual frame.
bool | has_virtual_frame () const
| Returns true if the virtual frame has a bounding rectangle; see set_virtual_frame().
virtual PandaNode * | make_copy () const
| Returns a newly-allocated Node that is a shallow copy of this one.
void | recompute ()
| Forces the PGScrollFrame to recompute itself right now.
void | remanage ()
| Manages the position and size of the scroll bars.
void | set_auto_hide (bool auto_hide)
| Sets the auto_hide flag.
void | set_horizontal_slider (PGSliderBar *horizontal_slider)
| Sets the PGSliderBar object that will serve as the horizontal scroll bar for this frame.
void | set_manage_pieces (bool manage_pieces)
| Sets the manage_pieces flag.
void | set_vertical_slider (PGSliderBar *vertical_slider)
| Sets the PGSliderBar object that will serve as the vertical scroll bar for this frame.
void | set_virtual_frame (const LVecBase4 &virtual_frame)
| Sets the bounding rectangle of the virtual frame.
void | set_virtual_frame (PN_stdfloat left, PN_stdfloat right, PN_stdfloat bottom, PN_stdfloat top)
| Sets the bounding rectangle of the virtual frame.
void | setup (PN_stdfloat width, PN_stdfloat height, PN_stdfloat left, PN_stdfloat right, PN_stdfloat bottom, PN_stdfloat top, PN_stdfloat slider_width, PN_stdfloat bevel)
| Creates a PGScrollFrame with the indicated dimensions, and the indicated virtual frame.
virtual void | xform (const LMatrix4 &mat)
| Transforms the contents of this node by the indicated matrix, if it means anything to do so.
Public Member Functions inherited from PGVirtualFrame
| PGVirtualFrame (const std::string &name="")
void | clear_clip_frame ()
| Removes the clip frame from the item.
PandaNode * | get_canvas_node () const
| Returns the special node that holds all of the children that appear in the virtual canvas.
PandaNode * | get_canvas_parent () const
| Returns the parent node of the canvas_node.
const TransformState * | get_canvas_transform () const
| Returns the transform of the virtual canvas.
const LVecBase4 & | get_clip_frame () const
| Returns the bounding rectangle of the clip frame.
bool | has_clip_frame () const
| Returns true if the clip frame has been set; see set_clip_frame().
void | set_canvas_transform (const TransformState *transform)
| Changes the transform of the virtual canvas.
void | set_clip_frame (const LVecBase4 &clip_frame)
| Sets the bounding rectangle of the clip frame.
void | set_clip_frame (PN_stdfloat left, PN_stdfloat right, PN_stdfloat bottom, PN_stdfloat top)
| Sets the bounding rectangle of the clip frame.
void | setup (PN_stdfloat width, PN_stdfloat height)
| Creates a PGVirtualFrame with the indicated dimensions.
Public Member Functions inherited from PGItem
| PGItem (const std::string &name)
virtual void | candidate (const MouseWatcherParameter &param, bool background)
| This is a callback hook function, called whenever the user highlights an option in the IME window.
void | clear_frame ()
| Removes the bounding rectangle from the item.
void | clear_state_def (int state)
| Resets the NodePath assigned to the indicated state to its initial default, with only a frame representation if appropriate.
virtual void | enter_region (const MouseWatcherParameter &param)
| This is a callback hook function, called whenever the mouse enters the region.
virtual void | exit_region (const MouseWatcherParameter &param)
| This is a callback hook function, called whenever the mouse exits the region.
virtual void | focus_in ()
| This is a callback hook function, called whenever the widget gets the keyboard focus.
virtual void | focus_out ()
| This is a callback hook function, called whenever the widget loses the keyboard focus.
bool | get_active () const
| Returns whether the PGItem is currently active for mouse events.
bool | get_background_focus () const
| Returns whether background_focus is currently enabled.
std::string | get_enter_event () const
| Returns the event name that will be thrown when the item is active and the mouse enters its frame, but not any nested frames.
std::string | get_exit_event () const
| Returns the event name that will be thrown when the item is active and the mouse exits its frame, or enters a nested frame.
bool | get_focus () const
| Returns whether the PGItem currently has focus for keyboard events.
std::string | get_focus_in_event () const
| Returns the event name that will be thrown when the item gets the keyboard focus.
std::string | get_focus_out_event () const
| Returns the event name that will be thrown when the item loses the keyboard focus.
const LVecBase4 & | get_frame () const
| Returns the bounding rectangle of the item.
LMatrix4 | get_frame_inv_xform () const
| Returns the inverse of the frame transform matrix.
PGFrameStyle | get_frame_style (int state)
| Returns the kind of frame that will be drawn behind the item when it is in the indicated state.
const std::string & | get_id () const
| Returns the unique ID assigned to this PGItem.
std::string | get_keystroke_event () const
| Returns the event name that will be thrown when the item is active and any key is pressed by the user.
PGItemNotify * | get_notify () const
| Returns the object which will be notified when the PGItem changes, if any.
int | get_num_state_defs () const
std::string | get_press_event (const ButtonHandle &button) const
| Returns the event name that will be thrown when the item is active and the indicated mouse or keyboard button is depressed while the mouse is within the frame.
PGMouseWatcherRegion * | get_region () const
| Returns the MouseWatcherRegion associated with this item.
std::string | get_release_event (const ButtonHandle &button) const
| Returns the event name that will be thrown when the item is active and the indicated mouse or keyboard button, formerly clicked down is within the frame, is released.
std::string | get_repeat_event (const ButtonHandle &button) const
| Returns the event name that will be thrown when the item is active and the indicated mouse or keyboard button is continuously held down while the mouse is within the frame.
int | get_state () const
| Returns the "state" of this particular PGItem.
NodePath & | get_state_def (int state)
int | get_suppress_flags () const
| This is just an interface to get the suppress flags on the underlying MouseWatcherRegion.
std::string | get_within_event () const
| Returns the event name that will be thrown when the item is active and the mouse moves within the boundaries of the frame.
std::string | get_without_event () const
| Returns the event name that will be thrown when the item is active and the mouse moves completely outside the boundaries of the frame.
bool | has_frame () const
| Returns true if the item has a bounding rectangle; see set_frame().
bool | has_notify () const
| Returns true if there is an object configured to be notified when the PGItem changes, false otherwise.
bool | has_state_def (int state) const
| Returns true if get_state_def() has ever been called for the indicated state (thus defining a render subgraph for this state index), false otherwise.
NodePath | instance_to_state_def (int state, const NodePath &path)
| Parents an instance of the bottom node of the indicated NodePath to the indicated state index.
virtual void | keystroke (const MouseWatcherParameter &param, bool background)
| This is a callback hook function, called whenever the user presses a key.
virtual void | move (const MouseWatcherParameter &param)
| This is a callback hook function, called whenever a mouse is moved while within the region.
virtual void | press (const MouseWatcherParameter &param, bool background)
| This is a callback hook function, called whenever a mouse or keyboard button is depressed while the mouse is within the region.
virtual void | release (const MouseWatcherParameter &param, bool background)
| This is a callback hook function, called whenever a mouse or keyboard button previously depressed with press() is released.
virtual void | set_active (bool active)
| Sets whether the PGItem is active for mouse watching.
void | set_background_focus (bool focus)
| Sets the background_focus flag for this item.
virtual void | set_focus (bool focus)
| Sets whether the PGItem currently has keyboard focus.
void | set_frame (const LVecBase4 &frame)
| Sets the bounding rectangle of the item, in local coordinates.
void | set_frame (PN_stdfloat left, PN_stdfloat right, PN_stdfloat bottom, PN_stdfloat top)
| Sets the bounding rectangle of the item, in local coordinates.
void | set_frame_style (int state, const PGFrameStyle &style)
| Changes the kind of frame that will be drawn behind the item when it is in the indicated state.
void | set_id (const std::string &id)
| Set the unique ID assigned to this PGItem.
void | set_name (const std::string &name)
void | set_notify (PGItemNotify *notify)
| Sets the object which will be notified when the PGItem changes.
void | set_state (int state)
| Sets the "state" of this particular PGItem.
void | set_suppress_flags (int suppress_flags)
| This is just an interface to set the suppress flags on the underlying MouseWatcherRegion.
virtual void | within_region (const MouseWatcherParameter &param)
| This is a callback hook function, called whenever the mouse moves within the boundaries of the region, even if it is also within the boundaries of a nested region.
virtual void | without_region (const MouseWatcherParameter &param)
| This is a callback hook function, called whenever the mouse moves completely outside the boundaries of the region.
Public Member Functions inherited from PandaNode
| PandaNode (const std::string &name)
void | add_child (PandaNode *child_node, int sort=0, Thread *current_thread=Thread::get_current_thread())
| Adds a new child to the node.
virtual void | add_for_draw (CullTraverser *trav, CullTraverserData &data)
| Adds the node's contents to the CullResult we are building up during the cull traversal, so that it will be drawn at render time.
void | add_stashed (PandaNode *child_node, int sort=0, Thread *current_thread=Thread::get_current_thread())
| Adds a new child to the node, directly as a stashed child.
void | adjust_draw_mask (DrawMask show_mask, DrawMask hide_mask, DrawMask clear_mask)
| Adjusts the hide/show bits of this particular node.
virtual void | apply_attribs_to_vertices (const AccumulatedAttribs &attribs, int attrib_types, GeomTransformer &transformer)
| Applies whatever attributes are specified in the AccumulatedAttribs object (and by the attrib_types bitmask) to the vertices on this node, if appropriate.
virtual Light * | as_light ()
| Cross-casts the node to a Light pointer, if it is one of the four kinds of Light nodes, or returns NULL if it is not.
virtual ConstPointerTo< TransformState > | calc_tight_bounds (LPoint3 &min_point, LPoint3 &max_point, bool &found_any, const TransformState *transform, Thread *current_thread=Thread::get_current_thread()) const
| This is used to support NodePath::calc_tight_bounds().
void | clear_attrib (int slot)
| Removes the render attribute of the given type from this node.
void | clear_attrib (TypeHandle type)
void | clear_bounds ()
| Reverses the effect of a previous call to set_bounds(), and allows the node's bounding volume to be automatically computed once more based on the contents of the node.
void | clear_effect (TypeHandle type)
| Removes the render effect of the given type from this node.
void | clear_effects (Thread *current_thread=Thread::get_current_thread())
void | clear_state (Thread *current_thread=Thread::get_current_thread())
void | clear_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread())
void | clear_transform (Thread *current_thread=Thread::get_current_thread())
void | clear_unexpected_change (unsigned int flags)
| Sets one or more of the PandaNode::UnexpectedChange bits off, indicating that the corresponding property may once again change on this node.
virtual PandaNode * | combine_with (PandaNode *other)
| Collapses this PandaNode with the other PandaNode, if possible, and returns a pointer to the combined PandaNode, or NULL if the two PandaNodes cannot safely be combined.
int | compare_tags (const PandaNode *other) const
| Returns a number less than 0, 0, or greater than 0, to indicate the similarity of tags between this node and the other one.
void | copy_all_properties (PandaNode *other)
| Copies the TransformState, RenderState, RenderEffects, tags, Python tags, and the show/hide state from the other node onto this one.
void | copy_children (PandaNode *other, Thread *current_thread=Thread::get_current_thread())
| Makes another instance of all the children of the other node, copying them to this node.
PointerTo< PandaNode > | copy_subgraph (Thread *current_thread=Thread::get_current_thread()) const
| Allocates and returns a complete copy of this PandaNode and the entire scene graph rooted at this PandaNode.
void | copy_tags (PandaNode *other)
| Copies all of the tags stored on the other node onto this node.
int | count_num_descendants () const
| Returns the number of nodes at and below this level.
virtual PandaNode * | dupe_for_flatten () const
| This is similar to make_copy(), but it makes a copy for the specific purpose of flatten.
int | find_child (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated child node, if it is a child, or -1 if it is not.
int | find_parent (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated parent node, if it is a parent, or -1 if it is not.
int | find_stashed (PandaNode *node, Thread *current_thread=Thread::get_current_thread()) const
| Returns the index of the indicated stashed node, if it is a stashed child, or -1 if it is not.
ConstPointerTo< RenderAttrib > | get_attrib (int slot) const
ConstPointerTo< RenderAttrib > | get_attrib (TypeHandle type) const
ConstPointerTo< BoundingVolume > | get_bounds (Thread *current_thread=Thread::get_current_thread()) const
| Returns the external bounding volume of this node: a bounding volume that contains the user bounding volume, the internal bounding volume, and all of the children's bounding volumes.
ConstPointerTo< BoundingVolume > | get_bounds (UpdateSeq &seq, Thread *current_thread=Thread::get_current_thread()) const
| This flavor of get_bounds() return the external bounding volume, and also fills in seq with the bounding volume's current sequence number.
BoundingVolume::BoundsType | get_bounds_type () const
PandaNode * | get_child (int n, Thread *current_thread=Thread::get_current_thread()) const
int | get_child_sort (int n, Thread *current_thread=Thread::get_current_thread()) const
| Returns the sort index of the nth child node of this node (that is, the number that was passed to add_child()).
Children | get_children (Thread *current_thread=Thread::get_current_thread()) const
DrawMask | get_draw_control_mask () const
DrawMask | get_draw_show_mask () const
ConstPointerTo< RenderEffect > | get_effect (TypeHandle type) const
ConstPointerTo< RenderEffects > | get_effects (Thread *current_thread=Thread::get_current_thread()) const
int | get_fancy_bits (Thread *current_thread=Thread::get_current_thread()) const
| Returns the union of all of the enum FancyBits values corresponding to the various "fancy" attributes that are set on the node.
virtual int | get_first_visible_child () const
| Returns the index number of the first visible child of this node, or a number >= get_num_children() if there are no visible children of this node.
ConstPointerTo< BoundingVolume > | get_internal_bounds (Thread *current_thread=Thread::get_current_thread()) const
int | get_internal_vertices (Thread *current_thread=Thread::get_current_thread()) const
CollideMask | get_into_collide_mask () const
virtual CollideMask | get_legal_collide_mask () const
int | get_nested_vertices (Thread *current_thread=Thread::get_current_thread()) const
CollideMask | get_net_collide_mask (Thread *current_thread=Thread::get_current_thread()) const
| Returns the union of all into_collide_mask() values set at CollisionNodes at this level and below.
DrawMask | get_net_draw_control_mask () const
| Returns the set of bits in get_net_draw_show_mask() that have been explicitly set via adjust_draw_mask(), rather than implicitly inherited.
DrawMask | get_net_draw_show_mask () const
| Returns the union of all draw_show_mask values–of renderable nodes only– at this level and below.
virtual int | get_next_visible_child (int n) const
| Returns the index number of the next visible child of this node following the indicated child, or a number >= get_num_children() if there are no more visible children of this node.
int | get_num_children (Thread *current_thread=Thread::get_current_thread()) const
int | get_num_parents (Thread *current_thread=Thread::get_current_thread()) const
int | get_num_stashed (Thread *current_thread=Thread::get_current_thread()) const
size_t | get_num_tags () const
ConstPointerTo< RenderAttrib > | get_off_clip_planes (Thread *current_thread=Thread::get_current_thread()) const
| Returns a ClipPlaneAttrib which represents the union of all of the clip planes that have been turned *off* at this level and below.
PandaNode * | get_parent (int n, Thread *current_thread=Thread::get_current_thread()) const
Parents | get_parents (Thread *current_thread=Thread::get_current_thread()) const
ConstPointerTo< TransformState > | get_prev_transform (Thread *current_thread=Thread::get_current_thread()) const
PandaNode * | get_stashed (int n, Thread *current_thread=Thread::get_current_thread()) const
Stashed | get_stashed (Thread *current_thread=Thread::get_current_thread()) const
int | get_stashed_sort (int n, Thread *current_thread=Thread::get_current_thread()) const
| Returns the sort index of the nth stashed node of this node (that is, the number that was passed to add_child()).
ConstPointerTo< RenderState > | get_state (Thread *current_thread=Thread::get_current_thread()) const
std::string | get_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread()) const
std::string | get_tag_key (size_t i) const
void | get_tag_keys (vector_string &keys) const
| Fills the given vector up with the list of tags on this PandaNode.
ConstPointerTo< TransformState > | get_transform (Thread *current_thread=Thread::get_current_thread()) const
unsigned int | get_unexpected_change (unsigned int flags) const
| Returns nonzero if any of the bits in the input parameter are set on this node, or zero if none of them are set.
virtual int | get_unsafe_to_apply_attribs () const
| Returns the union of all attributes from SceneGraphReducer::AttribTypes that may not safely be applied to the vertices of this node.
virtual int | get_visible_child () const
| Returns the index number of the currently visible child of this node.
bool | has_attrib (int slot) const
bool | has_attrib (TypeHandle type) const
bool | has_dirty_prev_transform () const
bool | has_effect (TypeHandle type) const
virtual bool | has_selective_visibility () const
| Should be overridden by derived classes to return true if this kind of node has some restrictions on the set of children that should be rendered.
virtual bool | has_single_child_visibility () const
| Should be overridden by derived classes to return true if this kind of node has the special property that just one of its children is visible at any given time, and furthermore that the particular visible child can be determined without reference to any external information (such as a camera).
bool | has_tag (const std::string &key, Thread *current_thread=Thread::get_current_thread()) const
bool | has_tags () const
virtual bool | is_ambient_light () const
| Returns true if this is an AmbientLight, false if it is not a light, or it is some other kind of light.
bool | is_bounds_stale () const
virtual bool | is_collision_node () const
| A simple downcast check.
bool | is_final (Thread *current_thread=Thread::get_current_thread()) const
virtual bool | is_geom_node () const
| A simple downcast check.
virtual bool | is_lod_node () const
| A simple downcast check.
bool | is_overall_hidden () const
bool | is_scene_root () const
| Returns true if this particular node is known to be the render root of some active DisplayRegion associated with the global GraphicsEngine, false otherwise.
bool | is_under_scene_root () const
| Returns true if this particular node is in a live scene graph: that is, it is a child or descendent of a node that is itself a scene root.
void | list_tags (std::ostream &out, const std::string &separator="\n") const
| Writes a list of all the tag keys assigned to the node to the indicated stream.
void | ls (std::ostream &out, int indent_level) const
void | mark_bounds_stale (Thread *current_thread=Thread::get_current_thread()) const
| Indicates that the bounding volume, or something that influences the bounding volume (or any of the other things stored in CData, like net_collide_mask), may have changed for this node, and that it must be recomputed.
void | mark_internal_bounds_stale (Thread *current_thread=Thread::get_current_thread())
| Should be called by a derived class to mark the internal bounding volume stale, so that compute_internal_bounds() will be called when the bounding volume is next requested.
virtual void | output (std::ostream &out) const
void | prepare_scene (GraphicsStateGuardianBase *gsg, const RenderState *node_state)
| Walks through the scene graph beginning at this node, and does whatever initialization is required to render the scene properly with the indicated GSG.
virtual bool | preserve_name () const
| Returns true if the node's name has extrinsic meaning and must be preserved across a flatten operation, false otherwise.
void | remove_all_children (Thread *current_thread=Thread::get_current_thread())
| Removes all the children from the node at once, including stashed children.
void | remove_child (int child_index, Thread *current_thread=Thread::get_current_thread())
| Removes the nth child from the node.
bool | remove_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Removes the indicated child from the node.
void | remove_stashed (int child_index, Thread *current_thread=Thread::get_current_thread())
| Removes the nth stashed child from the node.
bool | replace_child (PandaNode *orig_child, PandaNode *new_child, Thread *current_thread=Thread::get_current_thread())
| Searches for the orig_child node in the node's list of children, and replaces it with the new_child instead.
void | replace_node (PandaNode *other)
| Inserts this node into the scene graph in place of the other one, and removes the other node.
void | reset_prev_transform (Thread *current_thread=Thread::get_current_thread())
| Resets the transform that represents this node's "previous" position to the same as the current transform.
virtual bool | safe_to_combine () const
| Returns true if it is generally safe to combine this particular kind of PandaNode with other kinds of PandaNodes of compatible type, adding children or whatever.
virtual bool | safe_to_combine_children () const
| Returns true if it is generally safe to combine the children of this PandaNode with each other.
virtual bool | safe_to_flatten () const
| Returns true if it is generally safe to flatten out this particular kind of PandaNode by duplicating instances (by calling dupe_for_flatten()), false otherwise (for instance, a Camera cannot be safely flattened, because the Camera pointer itself is meaningful).
virtual bool | safe_to_flatten_below () const
| Returns true if a flatten operation may safely continue past this node, or false if nodes below this node may not be molested.
virtual bool | safe_to_modify_transform () const
| Returns true if it is safe to automatically adjust the transform on this kind of node.
virtual bool | safe_to_transform () const
| Returns true if it is generally safe to transform this particular kind of PandaNode by calling the xform() method, false otherwise.
void | set_attrib (const RenderAttrib *attrib, int override=0)
| Adds the indicated render attribute to the scene graph on this node.
void | set_bound (const BoundingVolume *volume)
void | set_bounds (const BoundingVolume *volume)
| Resets the bounding volume so that it is the indicated volume.
void | set_bounds_type (BoundingVolume::BoundsType bounds_type)
void | set_effect (const RenderEffect *effect)
| Adds the indicated render effect to the scene graph on this node.
void | set_effects (const RenderEffects *effects, Thread *current_thread=Thread::get_current_thread())
void | set_final (bool flag)
void | set_into_collide_mask (CollideMask mask)
void | set_overall_hidden (bool overall_hidden)
void | set_prev_transform (const TransformState *transform, Thread *current_thread=Thread::get_current_thread())
| Sets the transform that represents this node's "previous" position, one frame ago, for the purposes of detecting motion for accurate collision calculations.
void | set_state (const RenderState *state, Thread *current_thread=Thread::get_current_thread())
void | set_tag (const std::string &key, const std::string &value, Thread *current_thread=Thread::get_current_thread())
void | set_transform (const TransformState *transform, Thread *current_thread=Thread::get_current_thread())
void | set_unexpected_change (unsigned int flags)
| Sets one or more of the PandaNode::UnexpectedChange bits on, indicating that the corresponding property should not change again on this node.
void | stash_child (int child_index, Thread *current_thread=Thread::get_current_thread())
| Stashes the indicated child node.
bool | stash_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Stashes the indicated child node.
void | steal_children (PandaNode *other, Thread *current_thread=Thread::get_current_thread())
| Moves all the children from the other node onto this node.
void | unstash_child (int stashed_index, Thread *current_thread=Thread::get_current_thread())
| Returns the indicated stashed node to normal child status.
bool | unstash_child (PandaNode *child_node, Thread *current_thread=Thread::get_current_thread())
| Returns the indicated stashed node to normal child status.
virtual void | update_bam_nested (BamWriter *manager)
| Called by the BamWriter when this object has not itself been modified recently, but it should check its nested objects for updates.
virtual void | write (std::ostream &out, int indent_level) const
virtual void | write_datagram (BamWriter *manager, Datagram &dg)
| Writes the contents of this object to the datagram for shipping out to a Bam file.
void | write_recorder (BamWriter *manager, Datagram &dg)
| This method is provided for the benefit of classes (like MouseRecorder) that inherit from PandaMode and also RecorderBase.
Public Member Functions inherited from TypedWritableReferenceCount
| TypedWritableReferenceCount (const TypedWritableReferenceCount &copy)
virtual ReferenceCount * | as_reference_count ()
| Returns the pointer cast to a ReferenceCount pointer, if it is in fact of that type.
void | operator= (const TypedWritableReferenceCount &copy)
Public Member Functions inherited from TypedWritable
| TypedWritable (const TypedWritable &copy)
virtual int | complete_pointers (TypedWritable **p_list, BamReader *manager)
| Receives an array of pointers, one for each time manager->read_pointer() was called in fillin().
vector_uchar | encode_to_bam_stream () const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and returns that data as a bytes object.
bool | encode_to_bam_stream (vector_uchar &data, BamWriter *writer=nullptr) const
| Converts the TypedWritable object into a single stream of data using a BamWriter, and stores that data in the indicated string.
virtual void | finalize (BamReader *manager)
| Called by the BamReader to perform any final actions needed for setting up the object after all objects have been read and all pointers have been completed.
UpdateSeq | get_bam_modified () const
| Returns the current bam_modified counter.
void | mark_bam_modified ()
| Increments the bam_modified counter, so that this object will be invalidated and retransmitted on any open bam streams.
void | operator= (const TypedWritable &copy)
virtual bool | require_fully_complete () const
| Some objects require all of their nested pointers to have been completed before the objects themselves can be completed.
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.
Public Member Functions inherited from Namable
| Namable (const std::string &initial_name="")
void | clear_name ()
| Resets the Namable's name to empty.
const std::string & | get_name () const
bool | has_name () const
| Returns true if the Namable has a nonempty name set, false if the name is empty.
void | output (std::ostream &out) const
| Outputs the Namable.
void | set_name (const std::string &name)

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from PGVirtualFrame
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from PGItem
static void | background_candidate (const MouseWatcherParameter &param)
| Calls candidate() on all the PGItems with background focus.
static void | background_keystroke (const MouseWatcherParameter &param)
| Calls keystroke() on all the PGItems with background focus.
static void | background_press (const MouseWatcherParameter &param)
| Calls press() on all the PGItems with background focus.
static void | background_release (const MouseWatcherParameter &param)
| Calls release() on all the PGItems with background focus.
static TypeHandle | get_class_type ()
static std::string | get_enter_prefix ()
| Returns the prefix that is used to define the enter event for all PGItems.
static std::string | get_exit_prefix ()
| Returns the prefix that is used to define the exit event for all PGItems.
static std::string | get_focus_in_prefix ()
| Returns the prefix that is used to define the focus_in event for all PGItems.
static PGItem * | get_focus_item ()
| Returns the one PGItem in the world that currently has keyboard focus, if any, or NULL if no item has keyboard focus.
static std::string | get_focus_out_prefix ()
| Returns the prefix that is used to define the focus_out event for all PGItems.
static std::string | get_keystroke_prefix ()
| Returns the prefix that is used to define the keystroke event for all PGItems.
static std::string | get_press_prefix ()
| Returns the prefix that is used to define the press event for all PGItems.
static std::string | get_release_prefix ()
| Returns the prefix that is used to define the release event for all PGItems.
static std::string | get_repeat_prefix ()
| Returns the prefix that is used to define the repeat event for all PGItems.
static TextNode * | get_text_node ()
| Returns the TextNode object that will be used by all PGItems to generate default labels given a string.
static std::string | get_within_prefix ()
| Returns the prefix that is used to define the within event for all PGItems.
static std::string | get_without_prefix ()
| Returns the prefix that is used to define the without event for all PGItems.
static void | init_type ()
static void | set_text_node (TextNode *node)
| Changes the TextNode object that will be used by all PGItems to generate default labels given a string.
Static Public Member Functions inherited from PandaNode
static PointerTo< PandaNode > | decode_from_bam_stream (vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts and returns the single object on those bytes.
static DrawMask | get_all_camera_mask ()
static TypeHandle | get_class_type ()
static DrawMask | get_overall_bit ()
static void | init_type ()
static void | register_with_read_factory ()
| Tells the BamReader how to create objects of type PandaNode.
static void | reset_all_prev_transform (Thread *current_thread=Thread::get_current_thread())
| Visits all nodes in the world with the _dirty_prev_transform flag–that is, all nodes whose _prev_transform is different from the _transform in pipeline stage 0–and resets the _prev_transform to be the same as _transform.
static void | set_scene_root_func (SceneRootFunc *func)
| This is used by the GraphicsEngine to hook in a pointer to the scene_root_func(), the function to determine whether the node is an active scene root.
Static Public Member Functions inherited from TypedWritableReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
static | PT (TypedWritableReferenceCount) decode_from_bam_stream(vector_uchar data
Static Public Member Functions inherited from TypedWritable
static bool | decode_raw_from_bam_stream (TypedWritable *&ptr, ReferenceCount *&ref_ptr, vector_uchar data, BamReader *reader=nullptr)
| Reads the bytes created by a previous call to encode_to_bam_stream(), and extracts the single object on those bytes.
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from Namable
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Types inherited from PandaNode
enum | FancyBits { FB_transform = 0x0001 , FB_state = 0x0002 , FB_effects = 0x0004 , FB_tag = 0x0010 , FB_draw_mask = 0x0020 , FB_cull_callback = 0x0040 }
typedef bool | SceneRootFunc(const PandaNode *)
enum | UnexpectedChange { UC_parents = 0x001 , UC_children = 0x002 , UC_transform = 0x004 , UC_state = 0x008 , UC_draw_mask = 0x010 }
Public Attributes inherited from PGItem
| get_num_state_defs
| Returns one more than the highest-numbered state def that was ever assigned to the PGItem.
| get_state_def
| Returns the Node that is the root of the subgraph that will be drawn when the PGItem is in the indicated state.
Public Attributes inherited from PandaNode
| clear_tag
| Removes the value defined for this key on this particular node.
| get_all_camera_mask
| Returns a DrawMask that is appropriate for rendering to all cameras.
| get_bounds_type
| Returns the bounding volume type set with set_bounds_type().
| get_child
| Returns the nth child node of this node.
| get_children
| Returns an object that can be used to walk through the list of children of the node.
| get_draw_control_mask
| Returns the set of bits in draw_show_mask that are considered meaningful.
| get_draw_show_mask
| Returns the hide/show bits of this particular node.
| get_effects
| get_internal_bounds
| Returns the node's internal bounding volume.
| get_internal_vertices
| Returns the total number of vertices that will be rendered by this particular node alone, not accounting for its children.
| get_into_collide_mask
| Returns the "into" collide mask for this node.
| get_legal_collide_mask
| Returns the subset of CollideMask bits that may be set for this particular type of PandaNode.
| get_nested_vertices
| Returns the total number of vertices that will be rendered by this node and all of its descendents.
| get_num_children
| Returns the number of child nodes this node has.
| get_num_parents
| Returns the number of parent nodes this node has.
| get_num_stashed
| Returns the number of stashed nodes this node has.
| get_num_tags
| get_overall_bit
| get_parent
| Returns the nth parent node of this node.
| get_parents
| Returns an object that can be used to walk through the list of parents of the node, similar to get_children() and get_stashed().
| get_prev_transform
| get_python_tags
| get_stashed
| Returns the nth stashed child of this node.
| get_state
| get_tag
| get_tag_key
| get_transform
| has_tag
| is_bounds_stale
| is_final
| Returns the current state of the "final" flag.
| is_overall_hidden
| Returns true if the node has been hidden to all cameras by clearing its overall bit.
| set_bounds_type
| Specifies the desired type of bounding volume that will be created for this node.
| set_effects
| Sets the complete RenderEffects that will be applied this node.
| set_final
| set_into_collide_mask
| Sets the "into" CollideMask.
| set_overall_hidden
| Sets or clears the hidden flag.
| set_state
| Sets the complete RenderState that will be applied to all nodes at this level and below.
| set_tag
| Associates a user-defined value with a user-defined key which is stored on the node.
| set_transform
| Sets the transform that will be applied to this node and below.
Public Attributes inherited from TypedWritableReferenceCount
static BamReader * | reader = nullptr)
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.
Public Attributes inherited from Namable
| get_name
| set_name
Static Public Attributes inherited from TypedWritable
static TypedWritable *const | Null = nullptr

## Detailed Description

This is a special kind of frame that pretends to be much larger than it actually is.

You can scroll through the frame, as if you're looking through a window at the larger frame beneath. All children of this frame node are scrolled and clipped as if they were children of the larger, virtual frame.

This is implemented as a specialization of PGVirtualFrame, which handles the meat of the virtual canvas. This class adds automatic support for scroll bars, and restricts the virtual transform to translate only (no scale or rotate).

Definition at line 39 of file pgScrollFrame.h.

## Constructor & Destructor Documentation

## ◆ PGScrollFrame()

PGScrollFrame::PGScrollFrame | ( | const std::string & | name = "" | ) |
| explicit

Definition at line 21 of file pgScrollFrame.cxx.

## ◆ ~PGScrollFrame()

PGScrollFrame::~PGScrollFrame | ( |  | ) |
| virtual

Definition at line 39 of file pgScrollFrame.cxx.

## Member Function Documentation

## ◆ clear_horizontal_slider()

void PGScrollFrame::clear_horizontal_slider | ( |  | ) |
| inline

Removes the horizontal scroll bar from control of the frame.

It is your responsibility to actually remove or hide the object itself.

Definition at line 144 of file pgScrollFrame.I.

References set_horizontal_slider().

## ◆ clear_vertical_slider()

void PGScrollFrame::clear_vertical_slider | ( |  | ) |
| inline

Removes the vertical scroll bar from control of the frame.

It is your responsibility to actually remove or hide the object itself.

Definition at line 181 of file pgScrollFrame.I.

References set_vertical_slider().

## ◆ clear_virtual_frame()

void PGScrollFrame::clear_virtual_frame | ( |  | ) |
| inline

Removes the virtual frame from the item.

This effectively sets the virtual frame to the same size as the clip frame. Scrolling will no longer be possible.

Definition at line 65 of file pgScrollFrame.I.

## ◆ cull_callback()

bool PGScrollFrame::cull_callback | ( | CullTraverser * | trav,
|  | CullTraverserData & | data )
| virtual

This function will be called during the cull traversal to perform any additional operations that should be performed at cull time.

This may include additional manipulation of render state or additional visible/invisible decisions, or any other arbitrary operation.

Note that this function will *not* be called unless set_cull_callback() is called in the constructor of the derived class. It is necessary to call set_cull_callback() to indicated that we require cull_callback() to be called.

By the time this function is called, the node has already passed the bounding-volume test for the viewing frustum, and the node's transform and state have already been applied to the indicated CullTraverserData object.

The return value is true if this node should be visible, or false if it should be culled.

Reimplemented from PGItem.

Definition at line 90 of file pgScrollFrame.cxx.

References PandaNode::cull_callback(), and remanage().

## ◆ force_init_type()

virtual TypeHandle PGScrollFrame::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from PGVirtualFrame.

Definition at line 122 of file pgScrollFrame.h.

## ◆ get_auto_hide()

bool PGScrollFrame::get_auto_hide | ( |  | ) | const
| inline

Returns the auto_hide flag.

See set_auto_hide().

Definition at line 116 of file pgScrollFrame.I.

## ◆ get_class_type()

static TypeHandle PGScrollFrame::get_class_type | ( |  | ) |
| inline static

Definition at line 111 of file pgScrollFrame.h.

## ◆ get_horizontal_slider()

PGSliderBar * PGScrollFrame::get_horizontal_slider | ( |  | ) | const
| inline

Returns the PGSliderBar that serves as the horizontal scroll bar for this frame, if any, or NULL if it is not set.

Definition at line 153 of file pgScrollFrame.I.

## ◆ get_manage_pieces()

bool PGScrollFrame::get_manage_pieces | ( |  | ) | const
| inline

Returns the manage_pieces flag.

See set_manage_pieces().

Definition at line 89 of file pgScrollFrame.I.

## ◆ get_type()

virtual TypeHandle PGScrollFrame::get_type | ( |  | ) | const
| inline virtual

Reimplemented from PGVirtualFrame.

Definition at line 119 of file pgScrollFrame.h.

## ◆ get_vertical_slider()

PGSliderBar * PGScrollFrame::get_vertical_slider | ( |  | ) | const
| inline

Returns the PGSliderBar that serves as the vertical scroll bar for this frame, if any, or NULL if it is not set.

Definition at line 190 of file pgScrollFrame.I.

## ◆ get_virtual_frame()

const LVecBase4 & PGScrollFrame::get_virtual_frame | ( |  | ) | const
| inline

Returns the bounding rectangle of the virtual frame.

See set_virtual_frame(). If has_virtual_frame() is false, this returns the item's clip frame.

Definition at line 44 of file pgScrollFrame.I.

References PGVirtualFrame::get_clip_frame().

Referenced by remanage().

## ◆ has_virtual_frame()

bool PGScrollFrame::has_virtual_frame | ( |  | ) | const
| inline

Returns true if the virtual frame has a bounding rectangle; see set_virtual_frame().

Most PGScrollFrame objects will have a virtual frame.

Definition at line 54 of file pgScrollFrame.I.

## ◆ init_type()

static void PGScrollFrame::init_type | ( |  | ) |
| inline static

Definition at line 114 of file pgScrollFrame.h.

## ◆ make_copy()

PandaNode * PGScrollFrame::make_copy | ( |  | ) | const
| virtual

Returns a newly-allocated Node that is a shallow copy of this one.

It will be a different Node pointer, but its internal data may or may not be shared with that of the original Node.

Reimplemented from PGVirtualFrame.

Definition at line 66 of file pgScrollFrame.cxx.

## ◆ recompute()

void PGScrollFrame::recompute | ( |  | ) |
| inline

Forces the PGScrollFrame to recompute itself right now.

Normally this should not be required.

Definition at line 200 of file pgScrollFrame.I.

Referenced by remanage().

## ◆ remanage()

void PGScrollFrame::remanage | ( |  | ) |

Manages the position and size of the scroll bars.

Normally this should not need to be called directly.

Definition at line 175 of file pgScrollFrame.cxx.

References PGItem::get_frame(), PGItem::get_frame_style(), PGFrameStyle::get_internal_frame(), PGItem::get_state(), get_virtual_frame(), and recompute().

Referenced by cull_callback().

## ◆ set_auto_hide()

void PGScrollFrame::set_auto_hide | ( | bool | auto_hide | ) |
| inline

Sets the auto_hide flag.

When this is true, the two scroll bars are automatically hidden if they are not needed (that is, if the virtual frame would fit within the clip frame without them), and they are automatically shown when they are needed.

Setting this flag true forces the manage_pieces flag to also be set true.

Definition at line 103 of file pgScrollFrame.I.

References set_manage_pieces().

Referenced by setup().

## ◆ set_horizontal_slider()

void PGScrollFrame::set_horizontal_slider | ( | PGSliderBar * | horizontal_slider | ) |
| inline

Sets the PGSliderBar object that will serve as the horizontal scroll bar for this frame.

It is your responsibility to parent this slider bar to the frame and move it to the appropriate place.

Definition at line 127 of file pgScrollFrame.I.

Referenced by clear_horizontal_slider(), and setup().

## ◆ set_manage_pieces()

void PGScrollFrame::set_manage_pieces | ( | bool | manage_pieces | ) |
| inline

Sets the manage_pieces flag.

When this is true, the sub-pieces of the scroll frame–that is, the two scroll bars–are automatically positioned and/or resized when the scroll frame's overall frame is changed. They are also automatically resized to fill in the gap when one or the other is hidden.

Definition at line 78 of file pgScrollFrame.I.

Referenced by set_auto_hide(), and setup().

## ◆ set_vertical_slider()

void PGScrollFrame::set_vertical_slider | ( | PGSliderBar * | vertical_slider | ) |
| inline

Sets the PGSliderBar object that will serve as the vertical scroll bar for this frame.

It is your responsibility to parent this slider bar to the frame and move it to the appropriate place.

Definition at line 164 of file pgScrollFrame.I.

Referenced by clear_vertical_slider(), and setup().

## ◆ set_virtual_frame() [1/2]

void PGScrollFrame::set_virtual_frame | ( | const LVecBase4 & | frame | ) |
| inline

Sets the bounding rectangle of the virtual frame.

This is the size of the large, virtual canvas which we can see only a portion of at any given time.

Definition at line 27 of file pgScrollFrame.I.

## ◆ set_virtual_frame() [2/2]

void PGScrollFrame::set_virtual_frame | ( | PN_stdfloat | left,
|  | PN_stdfloat | right,
|  | PN_stdfloat | bottom,
|  | PN_stdfloat | top )
| inline

Sets the bounding rectangle of the virtual frame.

This is the size of the large, virtual canvas which we can see only a portion of at any given time.

Definition at line 18 of file pgScrollFrame.I.

References set_virtual_frame().

Referenced by set_virtual_frame(), and setup().

## ◆ setup()

void PGScrollFrame::setup | ( | PN_stdfloat | width,
|  | PN_stdfloat | height,
|  | PN_stdfloat | left,
|  | PN_stdfloat | right,
|  | PN_stdfloat | bottom,
|  | PN_stdfloat | top,
|  | PN_stdfloat | slider_width,
|  | PN_stdfloat | bevel )

Creates a PGScrollFrame with the indicated dimensions, and the indicated virtual frame.

Definition at line 122 of file pgScrollFrame.cxx.

References PandaNode::add_child(), PGItem::clear_state_def(), PandaNode::remove_child(), set_auto_hide(), PGVirtualFrame::set_clip_frame(), PGFrameStyle::set_color(), PGItem::set_frame(), PGItem::set_frame_style(), set_horizontal_slider(), set_manage_pieces(), PandaNode::set_state, PGFrameStyle::set_type(), set_vertical_slider(), set_virtual_frame(), and PGFrameStyle::set_width().

## ◆ xform()

void PGScrollFrame::xform | ( | const LMatrix4 & | mat | ) |
| virtual

Transforms the contents of this node by the indicated matrix, if it means anything to do so.

For most kinds of nodes, this does nothing.

Reimplemented from PGItem.

Definition at line 109 of file pgScrollFrame.cxx.

References PandaNode::xform().

The documentation for this class was generated from the following files:

- panda/src/pgui/pgScrollFrame.h
- panda/src/pgui/pgScrollFrame.cxx
- panda/src/pgui/pgScrollFrame.I